package common

import "git.sxidc.com/go-framework/baize/framework/core/data_protocol"

// MessageHandler 消息处理函数
// 参数:
// - queue: 消息队列
// - topic: 主题
// - data: 消息数据
// 返回值: 无
type MessageHandler func(queue MessageQueue, topic string, event *data_protocol.CloudEvent)

// MessageQueue 消息队列接口
type MessageQueue interface {
	Subscribe(group string, topic string, handler MessageHandler) error
	UnSubscribe(group string, topic string) error
	Publish(topic string, event *data_protocol.CloudEvent) error
}
